<?php

namespace FiloBlu\OrderFlowRectifier\Observer\Sales;

use Magento\Framework\Event\Observer;

class OrderPlaceBefore extends OrderPlaceBeforeAbstract
{
    public function execute(Observer $observer)
    {
        if($this->dataHelper->checkQuoteItemIsEnabled())
        {
            $missingQuoteItem = $this->checkQuote($observer);

            if(!empty($missingQuoteItem))
            {
                $this->dataHelper->log('QUOTE ID -> '.$missingQuoteItem['quote_id'].' / PRODUCT ITEM -> '.implode(" - ", $missingQuoteItem['item_data']));
                $this->dataHelper->log(debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, 20));
                $this->dataHelper->sendNotificationMail($missingQuoteItem, 'Place order');

                $productName = !empty($missingQuoteItem['product_name']) ? implode(' / ', $missingQuoteItem['product_name']) : '';
                $errorString = 'It is not possible to complete the order due to problems with some products.';
                if($productName != '')
                {
                    $errorString = 'It is not possible to complete the order due to problems with the following products: "'.$productName.'". ';
                    $errorString.= 'Please remove and add them again.';
                }

                throw new \Magento\Framework\Exception\LocalizedException(__($errorString));
            }
        }
    }
}